<template>
  <div class='crypto-slider container'>
    <client-only>
      <Flickity id='crypto-carousel' ref="flickity" :key='sliderKey' :options="flickityOptions">
        <crypto-slide v-for='(item, index) in slideContent' :key='index' :content='item' class='crypto-slider__item' />
      </Flickity>
    </client-only>

  </div>
</template>

<script>
import CryptoSlide from './CryptoSlide'
export default {
  components: { CryptoSlide },

  data() {
    return {
      slideContent: [
        {
          img: 'tbcc',
          fullName: 'TBCC',
          name: 'TBCC',
          price: '0.0885',
          percentChange: '+2.41',
          link: 'https://www.tbcc.com/trade/TBCC_USDT'
        },
        {
          img: 'bitcoin',
          fullName: 'Bitcoin',
          name: 'BTC',
          price: '29,198',
          percentChange: '+3.37',
          link: 'https://www.tbcc.com/trade/BTC_USDT'
        },
        {
          img: 'eth',
          fullName: 'Ethereum',
          name: 'ETH',
          price: '1,800',
          percentChange: '-2.57',
          link: 'https://www.tbcc.com/trade/ETH_USDT'
        },
        {
          img: 'bnb',
          fullName: 'BinanceCoin',
          name: 'BNB',
          price: '305.8',
          percentChange: '+1.98',
          link: 'https://www.tbcc.com/trade/BNB_USDT'
        },
      ],
      innerWidth: 0,
      sliderKey: 1,
    }
  },

  computed: {
    flickityOptions() {
      if( this.innerWidth > 920 && this.innerWidth < 1200) {
        return {
          pageDots: false,
          wrapAround: false,
          groupCells: 3,
          prevNextButtons: true,
          friction: 0.6
        }
      }
      if( this.innerWidth > 767 && this.innerWidth <= 920) {
        return {
          pageDots: false,
          wrapAround: false,
          groupCells: 2,
          prevNextButtons: true,
          friction: 0.6
        }
      }
      if(this.innerWidth <= 767) {
        return {
          pageDots: true,
          wrapAround: false,
          groupCells: 1,
          prevNextButtons: false,
        }
      }
      return {
        pageDots: false,
        wrapAround: false,
        groupCells: 4,
        prevNextButtons: true,
        friction: 0.6
      }
    }
  },

  watch: {
    flickityOptions() {
      this.sliderKey += 1
    }
  },

  mounted() {
    this.setWidth();
    window.addEventListener('resize', this.setWidth);
  },

  methods: {
    setWidth() {
      this.innerWidth = window.innerWidth
    }
  }
}
</script>

<style lang='scss' scoped>
.crypto-slider {
  position: relative;
  z-index: 1;
  max-width: 300px;

  @media (min-width: 768px) {
    max-width: 660px;
  }

  @media (min-width: 920px) {
    max-width: 878px;
  }

  @media (min-width: 1200px) {
    max-width: 1110px;
  }

  @media (min-width: 768px) {
    &::before {
      content: "";
      width: 601px;
      height: 459px;
      background-image: url("../../assets/img/bg-crypto-slider.svg");
      background-repeat: no-repeat;
      background-position: center;
      background-size: cover;
      left: 0;
      top: -75px;
      position: absolute;
      pointer-events: none;
      overflow: visible;
      z-index: -1;
    }
  }

  &__item {
    margin-right: 30px;
    width: calc((100% - 30px));

    @media (max-width: 767px) {
      max-width: 255px;
    }

    @media (min-width: 768px) {
      width: calc((100% - 60px) / 2);
    }

    @media (min-width: 920px) {
      width: calc((100% - 90px) / 3);
    }

    @media (min-width: 1200px) {
      width: calc((100% - 120px) / 4);
    }
  }
}
</style>
